/***
 * Excerpted from "Domain-Driven Design Using Naked Objects",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/dhnako for more book information.
***/
public String validatePayUsing(final PaymentMethod paymentMethod) {
    final ReasonBuffer buf = new ReasonBuffer();

    buf.appendOnCondition(
        paymentMethod.getOwner() != getVehicle().getPaymentMethodOwner(), 
        "Payment method must belong to this customer");
    
    buf.appendOnCondition(
            !paymentMethod.getCurrent(), "Payment method must be current");

    buf.append(paymentMethod.validatePay(this));
    return buf.getReason();
}
public List<PaymentMethod> choices0PayUsing() {
    return Collections.unmodifiableList(
            getVehicle().getPaymentMethodOwner().getPaymentMethods());
}
